"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "addClassesToSVGElement";

exports.type = "full";

exports.active = !1;

exports.description = "adds classnames to an outer <svg> element";

exports.params = {};

exports.fn = function(data, params) {
  if (!params || !(Array.isArray(params.classNames) && params.classNames.some(String) || params.className)) {
    console.error('Error in plugin "addClassesToSVGElement": absent parameters.\nIt should have a list of classes in "classNames" or one "className".\nConfig example:\n\nplugins:\n- addClassesToSVGElement:\n    className: "mySvg"\n\nplugins:\n- addClassesToSVGElement:\n    classNames: ["mySvg", "size-big"]\n');
    return data;
  }
  const classNames = params.classNames || [ params.className ];
  const svg = data.content[0];
  svg.isElem("svg") && svg.class.add.apply(svg.class, classNames);
  return data;
};