"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _collections = require("./_collections");

exports.name = "convertColors";

exports.type = "perItem";

exports.active = !0;

exports.description = "converts colors: rgb() to #rrggbb and #rrggbb to #rgb";

exports.params = {
  currentColor: !1,
  names2hex: !0,
  rgb2hex: !0,
  shorthex: !0,
  shortname: !0
};

const rNumber = "([+-]?(?:\\d*\\.\\d+|\\d+\\.?)%?)";

const regRGB = new RegExp("^rgb\\(\\s*" + rNumber + "\\s*,\\s*" + rNumber + "\\s*,\\s*" + rNumber + "\\s*\\)$");

const regHEX = /^#(([a-fA-F0-9])\2){3}$/;

const none = /\bnone\b/i;

exports.fn = function(item, params) {
  item.elem && item.eachAttr((function(attr) {
    if (_collections.colorsProps.indexOf(attr.name) > -1) {
      let val = attr.value;
      let match;
      if (params.currentColor) {
        match = "string" == typeof params.currentColor ? val === params.currentColor : params.currentColor.exec ? params.currentColor.exec(val) : !val.match(none);
        match && (val = "currentColor");
      }
      params.names2hex && val.toLowerCase() in _collections.colorsNames && (val = _collections.colorsNames[val.toLowerCase()]);
      if (params.rgb2hex && (match = val.match(regRGB))) {
        match = match.slice(1, 4).map((function(m) {
          m.indexOf("%") > -1 && (m = Math.round(2.55 * parseFloat(m)));
          return Math.max(0, Math.min(m, 255));
        }));
        val = "#" + ("00000" + ((rgb = match)[0] << 16 | rgb[1] << 8 | rgb[2]).toString(16)).slice(-6).toUpperCase();
      }
      params.shorthex && (match = val.match(regHEX)) && (val = "#" + match[0][1] + match[0][3] + match[0][5]);
      if (params.shortname) {
        const lowerVal = val.toLowerCase();
        lowerVal in _collections.colorsShortNames && (val = _collections.colorsShortNames[lowerVal]);
      }
      attr.value = val;
    }
    var rgb;
  }));
};