"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "convertEllipseToCircle";

exports.type = "perItem";

exports.active = !0;

exports.description = "converts non-eccentric <ellipse>s to <circle>s";

exports.params = {};

exports.fn = function(item) {
  if (item.isElem("ellipse")) {
    const rx = item.attr("rx").value || 0;
    const ry = item.attr("ry").value || 0;
    if (rx === ry || "auto" === rx || "auto" === ry) {
      const radius = "auto" !== rx ? rx : ry;
      item.renameElem("circle");
      item.removeAttr([ "rx", "ry" ]);
      item.addAttr({
        name: "r",
        value: radius,
        prefix: "",
        local: "r"
      });
    }
  }
};