"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

const stylingProps = require("./_collections").attrsGroups.presentation;

exports.name = "convertStyleToAttrs";

exports.type = "perItem";

exports.active = !0;

exports.description = "converts style to attributes";

exports.params = {
  keepImportant: !1
};

const rEscape = "\\\\(?:[0-9a-f]{1,6}\\s?|\\r\\n|.)";

const rAttr = "\\s*(" + g("[^:;\\\\]", rEscape) + "*?)\\s*";

const rSingleQuotes = "'(?:[^'\\n\\r\\\\]|" + rEscape + ")*?(?:'|$)";

const rQuotes = '"(?:[^"\\n\\r\\\\]|' + rEscape + ')*?(?:"|$)';

const rQuotedString = new RegExp("^" + g(rSingleQuotes, rQuotes) + "$");

const rParenthesis = "\\(" + g("[^'\"()\\\\]+", rEscape, rSingleQuotes, rQuotes) + "*?\\)";

const rValue = "\\s*(" + g("[^!'\"();\\\\]+?", rEscape, rSingleQuotes, rQuotes, rParenthesis, "[^;]*?") + "*?)";

const regDeclarationBlock = new RegExp(rAttr + ":" + rValue + "(\\s*!important(?![-(\\w]))?\\s*(?:;\\s*|$)", "ig");

const regStripComments = new RegExp(g(rEscape, rSingleQuotes, rQuotes, "/\\*[^]*?\\*/"), "ig");

exports.fn = function(item, params) {
  if (item.elem && item.hasAttr("style")) {
    let styleValue = item.attr("style").value;
    let styles = [];
    const attrs = {};
    styleValue = styleValue.replace(regStripComments, (function(match) {
      return "/" === match[0] ? "" : "\\" === match[0] && /[-g-z]/i.test(match[1]) ? match[1] : match;
    }));
    regDeclarationBlock.lastIndex = 0;
    for (let rule; rule = regDeclarationBlock.exec(styleValue); ) params.keepImportant && rule[3] || styles.push([ rule[1], rule[2] ]);
    if (styles.length) {
      styles = styles.filter((function(style) {
        if (style[0]) {
          const prop = style[0].toLowerCase();
          let val = style[1];
          rQuotedString.test(val) && (val = val.slice(1, -1));
          if (stylingProps.indexOf(prop) > -1) {
            attrs[prop] = {
              name: prop,
              value: val,
              local: prop,
              prefix: ""
            };
            return !1;
          }
        }
        return !0;
      }));
      Object.assign(item.attrs, attrs);
      styles.length ? item.attr("style").value = styles.map((function(declaration) {
        return declaration.join(":");
      })).join(";") : item.removeAttr("style");
    }
  }
};

function g() {
  return "(?:" + Array.prototype.join.call(arguments, "|") + ")";
}