"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _path = require("./_path");

exports.name = "mergePaths";

exports.type = "perItem";

exports.active = !0;

exports.description = "merges multiple paths in one if possible";

exports.params = {
  collapseRepeated: !0,
  force: !1,
  leadingZero: !0,
  negativeExtraSpace: !0,
  noSpaceAfterFlags: !0
};

exports.fn = function(item, params) {
  if (!item.isElem() || item.isEmpty()) return;
  let prevContentItem = null;
  let prevContentItemKeys = null;
  item.content = item.content.filter((function(contentItem) {
    if (prevContentItem && prevContentItem.isElem("path") && prevContentItem.isEmpty() && prevContentItem.hasAttr("d") && contentItem.isElem("path") && contentItem.isEmpty() && contentItem.hasAttr("d")) {
      prevContentItemKeys || (prevContentItemKeys = Object.keys(prevContentItem.attrs));
      const contentItemAttrs = Object.keys(contentItem.attrs);
      const equalData = prevContentItemKeys.length === contentItemAttrs.length && contentItemAttrs.every((function(key) {
        return "d" === key || prevContentItem.hasAttr(key) && prevContentItem.attr(key).value === contentItem.attr(key).value;
      }));
      const prevPathJS = (0, _path.path2js)(prevContentItem);
      const curPathJS = (0, _path.path2js)(contentItem);
      if (equalData && (params.force || !(0, _path.intersects)(prevPathJS, curPathJS))) {
        (0, _path.js2path)(prevContentItem, prevPathJS.concat(curPathJS), params);
        return !1;
      }
    }
    prevContentItem = contentItem;
    prevContentItemKeys = null;
    return !0;
  }));
};