"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _csso = require("csso");

exports.name = "minifyStyles";

exports.type = "full";

exports.active = !0;

exports.description = "minifies styles and removes unused styles based on usage data";

exports.params = {
  usage: {
    force: !1,
    ids: !0,
    classes: !0,
    tags: !0
  }
};

exports.fn = function(ast, options) {
  const minifyOptionsForStylesheet = cloneObject(options = options || {});
  const minifyOptionsForAttribute = cloneObject(options);
  const elems = function(ast) {
    return function walk(items, styles) {
      for (let i = 0; i < items.content.length; i++) {
        const item = items.content[i];
        item.content && walk(item, styles);
        (item.isElem("style") && !item.isEmpty() || item.isElem() && item.hasAttr("style")) && styles.push(item);
      }
      return styles;
    }(ast, []);
  }(ast);
  minifyOptionsForStylesheet.usage = function(ast, options) {
    let safe = !0;
    const usageData = {};
    let hasData = !1;
    const rawData = function walk(items, usageData) {
      for (let i = 0; i < items.content.length; i++) {
        const item = items.content[i];
        item.content && walk(item, usageData);
        item.isElem("script") && (safe = !1);
        if (item.isElem()) {
          usageData.tags[item.elem] = !0;
          item.hasAttr("id") && (usageData.ids[item.attr("id").value] = !0);
          item.hasAttr("class") && item.attr("class").value.replace(/^\s+|\s+$/g, "").split(/\s+/).forEach((function(className) {
            usageData.classes[className] = !0;
          }));
          item.attrs && Object.keys(item.attrs).some((function(name) {
            return /^on/i.test(name);
          })) && (safe = !1);
        }
      }
      return usageData;
    }(ast, {
      ids: Object.create(null),
      classes: Object.create(null),
      tags: Object.create(null)
    });
    !safe && options.usage && options.usage.force && (safe = !0);
    for (const key in rawData) if (shouldFilter(options, key)) {
      usageData[key] = Object.keys(rawData[key]);
      hasData = !0;
    }
    return safe && hasData ? usageData : null;
  }(ast, options);
  minifyOptionsForAttribute.usage = null;
  elems.forEach((function(elem) {
    if (elem.isElem("style")) {
      const styleCss = elem.content[0].text || elem.content[0].cdata || [];
      const DATA = styleCss.indexOf(">") >= 0 || styleCss.indexOf("<") >= 0 ? "cdata" : "text";
      elem.content[0][DATA] = (0, _csso.minify)(styleCss, minifyOptionsForStylesheet).css;
    } else {
      const elemStyle = elem.attr("style").value;
      elem.attr("style").value = (0, _csso.minifyBlock)(elemStyle, minifyOptionsForAttribute).css;
    }
  }));
  return ast;
};

function cloneObject(obj) {
  const result = {};
  for (const key in obj) result[key] = obj[key];
  return result;
}

function shouldFilter(options, name) {
  return "usage" in options == 0 || !(!options.usage || name in options.usage != 0) || Boolean(options.usage && options.usage[name]);
}