"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _collections = require("./_collections");

const pathElems = _collections.pathElems.concat([ "g", "text" ]);

exports.name = "moveGroupAttrsToElems";

exports.type = "perItem";

exports.active = !0;

exports.description = "moves some group attributes to the content elements";

exports.params = {};

exports.fn = function(item) {
  if (item.isElem("g") && item.hasAttr("transform") && !item.isEmpty() && !item.someAttr((function(attr) {
    return ~_collections.referencesProps.indexOf(attr.name) && ~attr.value.indexOf("url(");
  })) && item.content.every((function(inner) {
    return inner.isElem(pathElems) && !inner.hasAttr("id");
  }))) {
    item.content.forEach((function(inner) {
      const attr = item.attr("transform");
      inner.hasAttr("transform") ? inner.attr("transform").value = attr.value + " " + inner.attr("transform").value : inner.addAttr({
        name: attr.name,
        local: attr.local,
        prefix: attr.prefix,
        value: attr.value
      });
    }));
    item.removeAttr("transform");
  }
};