"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "removeElementsByAttr";

exports.type = "perItem";

exports.active = !1;

exports.description = "removes arbitrary elements by ID or className (disabled by default)";

exports.params = {
  id: [],
  class: []
};

exports.fn = function(item, params) {
  [ "id", "class" ].forEach((function(key) {
    Array.isArray(params[key]) || (params[key] = [ params[key] ]);
  }));
  if (!item.isElem()) return;
  const elemId = item.attr("id");
  if (elemId) return -1 === params.id.indexOf(elemId.value);
  const elemClass = item.attr("class");
  return elemClass ? !new RegExp(params.class.join("|")).test(elemClass.value) : void 0;
};