"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "removeHiddenElems";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes hidden elements (zero sized, with absent attributes)";

exports.params = {
  isHidden: !0,
  displayNone: !0,
  opacity0: !0,
  circleR0: !0,
  ellipseRX0: !0,
  ellipseRY0: !0,
  rectWidth0: !0,
  rectHeight0: !0,
  patternWidth0: !0,
  patternHeight0: !0,
  imageWidth0: !0,
  imageHeight0: !0,
  pathEmptyD: !0,
  polylineEmptyPoints: !0,
  polygonEmptyPoints: !0
};

const regValidPath = /M\s*(?:[-+]?(?:\d*\.\d+|\d+(?:\.|(?!\.)))([eE][-+]?\d+)?(?!\d)\s*,?\s*){2}\D*\d/i;

exports.fn = function(item, params) {
  if (item.elem) {
    if (params.isHidden && item.hasAttr("visibility", "hidden")) return !1;
    if (params.displayNone && item.hasAttr("display", "none")) return !1;
    if (params.opacity0 && item.hasAttr("opacity", "0")) return !1;
    if (params.circleR0 && item.isElem("circle") && item.isEmpty() && item.hasAttr("r", "0")) return !1;
    if (params.ellipseRX0 && item.isElem("ellipse") && item.isEmpty() && item.hasAttr("rx", "0")) return !1;
    if (params.ellipseRY0 && item.isElem("ellipse") && item.isEmpty() && item.hasAttr("ry", "0")) return !1;
    if (params.rectWidth0 && item.isElem("rect") && item.isEmpty() && item.hasAttr("width", "0")) return !1;
    if (params.rectHeight0 && params.rectWidth0 && item.isElem("rect") && item.isEmpty() && item.hasAttr("height", "0")) return !1;
    if (params.patternWidth0 && item.isElem("pattern") && item.hasAttr("width", "0")) return !1;
    if (params.patternHeight0 && item.isElem("pattern") && item.hasAttr("height", "0")) return !1;
    if (params.imageWidth0 && item.isElem("image") && item.hasAttr("width", "0")) return !1;
    if (params.imageHeight0 && item.isElem("image") && item.hasAttr("height", "0")) return !1;
    if (params.pathEmptyD && item.isElem("path") && (!item.hasAttr("d") || !regValidPath.test(item.attr("d").value))) return !1;
    if (params.polylineEmptyPoints && item.isElem("polyline") && !item.hasAttr("points")) return !1;
    if (params.polygonEmptyPoints && item.isElem("polygon") && !item.hasAttr("points")) return !1;
  }
};