"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _collections = require("./_collections");

exports.name = "removeUnknownsAndDefaults";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes unknown elements content and attributes, removes attrs with default values";

exports.params = {
  unknownContent: !0,
  unknownAttrs: !0,
  defaultAttrs: !0,
  uselessOverrides: !0,
  keepDataAttrs: !0,
  keepAriaAttrs: !0,
  keepRoleAttr: !1
};

for (var elem in _collections.elems) {
  if ((elem = _collections.elems[elem]).attrsGroups) {
    elem.attrs = elem.attrs || [];
    elem.attrsGroups.forEach((function(attrsGroupName) {
      elem.attrs = elem.attrs.concat(_collections.attrsGroups[attrsGroupName]);
      var groupDefaults = _collections.attrsGroupsDefaults[attrsGroupName];
      if (groupDefaults) {
        elem.defaults = elem.defaults || {};
        for (var attrName in groupDefaults) elem.defaults[attrName] = groupDefaults[attrName];
      }
    }));
  }
  if (elem.contentGroups) {
    elem.content = elem.content || [];
    elem.contentGroups.forEach((function(contentGroupName) {
      elem.content = elem.content.concat(_collections.elemsGroups[contentGroupName]);
    }));
  }
}

exports.fn = function(item, params) {
  if (item.isElem() && !item.prefix) {
    var elem = item.elem;
    params.unknownContent && !item.isEmpty() && _collections.elems[elem] && "foreignObject" !== elem && item.content.forEach((function(content, i) {
      content.isElem() && !content.prefix && (_collections.elems[elem].content && -1 === _collections.elems[elem].content.indexOf(content.elem) || !_collections.elems[elem].content && !_collections.elems[content.elem]) && item.content.splice(i, 1);
    }));
    _collections.elems[elem] && _collections.elems[elem].attrs && item.eachAttr((function(attr) {
      "xmlns" === attr.name || "xml" !== attr.prefix && attr.prefix || params.keepDataAttrs && 0 === attr.name.indexOf("data-") || params.keepAriaAttrs && 0 === attr.name.indexOf("aria-") || params.keepRoleAttr && "role" === attr.name || (params.unknownAttrs && -1 === _collections.elems[elem].attrs.indexOf(attr.name) || params.defaultAttrs && !item.hasAttr("id") && _collections.elems[elem].defaults && _collections.elems[elem].defaults[attr.name] === attr.value && (_collections.inheritableAttrs.indexOf(attr.name) < 0 || !item.parentNode.computedAttr(attr.name)) || params.uselessOverrides && !item.hasAttr("id") && _collections.presentationNonInheritableGroupAttrs.indexOf(attr.name) < 0 && _collections.inheritableAttrs.indexOf(attr.name) > -1 && item.parentNode.computedAttr(attr.name, attr.value)) && item.removeAttr(attr.name);
    }));
  }
};