"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

const nonRendering = require("./_collections").elemsGroups.nonRendering;

exports.name = "removeUselessDefs";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes elements in <defs> without id";

exports.params = {};

exports.fn = function(item) {
  if (item.isElem("defs")) {
    item.content && (item.content = getUsefulItems(item, []));
    if (item.isEmpty()) return !1;
  } else if (item.isElem(nonRendering) && !item.hasAttr("id")) return !1;
};

function getUsefulItems(item, usefulItems) {
  item.content.forEach((function(child) {
    if (child.hasAttr("id") || child.isElem("style")) {
      usefulItems.push(child);
      child.parentNode = item;
    } else child.isEmpty() || (child.content = getUsefulItems(child, usefulItems));
  }));
  return usefulItems;
}