"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

const shape = require("./_collections").elemsGroups.shape;

exports.name = "removeUselessStrokeAndFill";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes useless stroke and fill attributes";

exports.params = {
  stroke: !0,
  fill: !0,
  removeNone: !1,
  hasStyleOrScript: !1
};

const regStrokeProps = /^stroke/;

const regFillProps = /^fill-/;

const styleOrScript = [ "style", "script" ];

exports.fn = function(item, params) {
  item.isElem(styleOrScript) && (params.hasStyleOrScript = !0);
  if (!params.hasStyleOrScript && item.isElem(shape) && !item.computedAttr("id")) {
    const stroke = params.stroke && item.computedAttr("stroke");
    const fill = params.fill && !item.computedAttr("fill", "none");
    if (params.stroke && (!stroke || "none" === stroke || item.computedAttr("stroke-opacity", "0") || item.computedAttr("stroke-width", "0"))) {
      const parentStroke = item.parentNode.computedAttr("stroke");
      const declineStroke = parentStroke && "none" !== parentStroke;
      item.eachAttr((function(attr) {
        regStrokeProps.test(attr.name) && item.removeAttr(attr.name);
      }));
      declineStroke && item.addAttr({
        name: "stroke",
        value: "none",
        prefix: "",
        local: "stroke"
      });
    }
    if (params.fill && (!fill || item.computedAttr("fill-opacity", "0"))) {
      item.eachAttr((function(attr) {
        regFillProps.test(attr.name) && item.removeAttr(attr.name);
      }));
      fill && (item.hasAttr("fill") ? item.attr("fill").value = "none" : item.addAttr({
        name: "fill",
        value: "none",
        prefix: "",
        local: "fill"
      }));
    }
    if (params.removeNone && (!stroke || item.hasAttr("stroke") && "none" === item.attr("stroke").value) && (!fill || item.hasAttr("fill") && "none" === item.attr("fill").value)) return !1;
  }
};