"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "sortAttrs";

exports.type = "perItem";

exports.active = !1;

exports.description = "sorts element attributes (disabled by default)";

exports.params = {
  order: [ "id", "width", "height", "x", "x1", "x2", "y", "y1", "y2", "cx", "cy", "r", "fill", "stroke", "marker", "d", "points" ]
};

exports.fn = function(item, params) {
  const attrs = [];
  const sorted = {};
  const orderlen = params.order.length + 1;
  const xmlnsOrder = params.xmlnsOrder || "front";
  if (item.elem) {
    item.eachAttr((function(attr) {
      attrs.push(attr);
    }));
    attrs.sort((function(a, b) {
      if (a.prefix !== b.prefix) {
        if ("front" === xmlnsOrder) {
          if ("xmlns" === a.prefix) return -1;
          if ("xmlns" === b.prefix) return 1;
        }
        return a.prefix < b.prefix ? -1 : 1;
      }
      let aindex = orderlen;
      let bindex = orderlen;
      for (let i = 0; i < params.order.length; i++) {
        a.name === params.order[i] ? aindex = i : 0 === a.name.indexOf(params.order[i] + "-") && (aindex = i + .5);
        b.name === params.order[i] ? bindex = i : 0 === b.name.indexOf(params.order[i] + "-") && (bindex = i + .5);
      }
      return aindex !== bindex ? aindex - bindex : a.name < b.name ? -1 : 1;
    }));
    attrs.forEach((function(attr) {
      sorted[attr.name] = attr;
    }));
    item.attrs = sorted;
  }
};