"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "sortDefsChildren";

exports.type = "perItem";

exports.active = !0;

exports.description = "Sorts children of <defs> to improve compression";

exports.params = {};

exports.fn = function(item) {
  if (item.isElem("defs")) {
    if (item.content) {
      const frequency = item.content.reduce((function(frequency, child) {
        child.elem in frequency ? frequency[child.elem]++ : frequency[child.elem] = 1;
        return frequency;
      }), {});
      item.content.sort((function(a, b) {
        const frequencyComparison = frequency[b.elem] - frequency[a.elem];
        if (0 !== frequencyComparison) return frequencyComparison;
        const lengthComparison = b.elem.length - a.elem.length;
        return 0 !== lengthComparison ? lengthComparison : a.elem !== b.elem ? a.elem > b.elem ? -1 : 1 : 0;
      }));
    }
    return !0;
  }
};